//	UberNES Emulation Core
//  Copyright (C) 2004 Luke Molnar
//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 2 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA


////////////////////////////////////////////////////////////////////
// Nes Mapper #7:  AOROM
// Numerous games released by Rare Ltd. use this mapper, such as Battletoads, 
// Wizards & Warriors, and Solar Jetman.
////////////////////////////////////////////////////////////////////

#ifndef NES_MAPPER_7
#define NES_MAPPER_7

#include "../NesBaseMapper.h"


class NesMapper7 : public NesBaseMapper
{
public:	
	///////////////////////////////
	// Class Procedures
	///////////////////////////////
	NesMapper7(NesCartridge *linkCartridge, NesCPU *linkCPU, NesPPU *linkPPU);
	~NesMapper7() { };
	void write(Uint16 addr, unsigned char data);
	void initMemory();
	
	
	///////////////////////////////
	// Class Data Members
	///////////////////////////////
	// This data member stores the 32k bank of PRG-ROM that is currently
	// loaded into memory, and is used to prevent swappnig data in that
	// is already there
	int intBankMap32;
};

#endif 
