//	UberNES Emulation Core
//  Copyright (C) 2004 Luke Molnar
//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 2 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA


////////////////////////////////////////////////////////////////////
// Nes Mapper #23:  Konami VRC2 type B
// This mapper is used on several Japanese titles by Konami, such as
// Gryzor (Japanese Contra) and Getsufuu Maden.
//
// This mapper is basically the same as mapper #21 (Konami VRC4), that's
// why it's subclassed from said mapper #21
////////////////////////////////////////////////////////////////////

#ifndef NES_MAPPER_23
#define NES_MAPPER_23

#include "../NesBaseMapper.h"
#include "NesMapper021.h"


class NesMapper23 : public NesMapper21
{
public:
	///////////////////////////////
	// Class Procedures
	///////////////////////////////
	NesMapper23(NesCartridge *linkCartridge, NesCPU *linkCPU, NesPPU *linkPPU);
	~NesMapper23() { };	
	void write(Uint16 addr, unsigned char data);

private:
	unsigned char chrbanks[8];
};

#endif 
