//////////////////////////////////////////////////////////////////////
// Nes Mapper 3.cpp - Implementation of mapper #3 (CNROM)
//////////////////////////////////////////////////////////////////////

#include "NesMapper3.h"

NesMapper3::NesMapper3(NesCartridge *linkCartridge, NesCPU *linkCPU, NesPPU *linkPPU)
{
	mCartridge = linkCartridge;
	mCpu = linkCPU;
	mPpu = linkPPU;
	
	bytPRGCount = mCartridge->header.PRGROM_count;
	bytCHRCount = mCartridge->header.CHRROM_count;
	
	initMaps();
}


void NesMapper3::write(unsigned __int16 addr, unsigned char data)
{
	// Swap in 8K CHRROM bank	
	swapCHRBank8(data % bytCHRCount);	
}