////////////////////////////////////////////////////////////////////
// Nes Mapper #7:  AOROM
// Numerous games released by Rare Ltd. use this mapper, such as Battletoads, 
// Wizards & Warriors, and Solar Jetman.
////////////////////////////////////////////////////////////////////

#if !defined(NES_MAPPER_7
#define NES_MAPPER_7

#include "..\NesBaseMapper.h"
#include <windows.h>


class NesMapper7 : public NesBaseMapper
{
public:	
	///////////////////////////////
	// Class Procedures
	///////////////////////////////
	NesMapper7(NesCartridge *linkCartridge, NesCPU *linkCPU, NesPPU *linkPPU);
	~NesMapper7();	
	void write(unsigned __int16 addr, unsigned char data);
	void initMemory();
	
	
	///////////////////////////////
	// Class Data Members
	///////////////////////////////
	// This data member stores the 32k bank of PRG-ROM that is currently
	// loaded into memory, and is used to prevent swappnig data in that
	// is already there
	int intBankMap32;
};

#endif 
